package andante.agent;

import andante.orb.agent.MusicalAgentPOA;

public class MusicalAgentImpl extends MusicalAgentPOA {

  private MusicalAglet MAglet;

  public MusicalAgentImpl(MusicalAglet am) {
    MAglet = am;
  }

  public String id() { return MAglet.id(); }

  public String name() { return MAglet.name(); }
  
  public void processSequence (andante.orb.Note[] seq) {
    MAglet.processSequence(seq);
  }

  public void processNote (andante.orb.Note n) {
    MAglet.processNote(n);
  }

  public void processMessage (andante.orb.Message m) {
    MAglet.processMessage(m);
  }

  public void stop() {
    MAglet.stop();
  }
  public void play() {
    MAglet.play();
  }
  public boolean playing () {
    return MAglet.playing();
  }
  public void dispatch(String address) {
    MAglet.dispatch(address);
  }

  public void setProperty(String p, String v) {
    System.out.println(id() + ": setProperty " + p + " " + v);
    MAglet.setProperty(p,v);
  }
  
  public String getProperty(String p) {
    return MAglet.getProperty(p);
  }

  public String[] listPropertyNames () {
    return MAglet.listPropertyNames();
  }

  public andante.orb.agent.Property[] listProperties () {
    return MAglet.listProperties();
  }

  public void pulse() {
//    System.out.println(id() + ": pulse " + System.currentTimeMillis());
    MAglet.pulse();
  }

}
